// KeyboardDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "KeyboardDemo.h"
#include "KeyboardDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DEV_INFO struDevTemp = {0};
DEV_INFO struMessage = {0};
SERIAL_PORT_KEYBOARD_COMMAND_INFO struCommand = {0};
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

void g_StringLanType(char *szDstLan, char *szLanCn, char *szLanEn)
{
#ifdef DEMO_LAN_CN
    sprintf(szDstLan, "%s", szLanCn);	
#else	
    sprintf(szDstLan, "%s", szLanEn);
#endif
	return;
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyboardDemoDlg dialog

CKeyboardDemoDlg::CKeyboardDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKeyboardDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeyboardDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKeyboardDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyboardDemoDlg)
	DDX_Control(pDX, IDC_LIST_MESSAGE, m_listMessage);
	DDX_Control(pDX, IDC_LIST_DEV, m_listDev);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeyboardDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CKeyboardDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_START_SEARCH, OnBtnStartSearch)
	ON_BN_CLICKED(IDC_BTN_STOP_SEARCH, OnBtnStopSearch)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_EXIT, OnBtnExit)
	ON_BN_CLICKED(IDC_BTN_UPGRADE, OnBtnUpgrade)
	ON_BN_CLICKED(IDC_BUT_TEST, OnButTest)
	ON_WM_TIMER()
    ON_MESSAGE(MESSAGE_DEV_ONLINE, ProcessDevOnline)
    ON_MESSAGE(MESSAGE_DEV_OFFLINE, ProcessDevOffline)
    ON_MESSAGE(MESSAGE_ADD_MESSAGE, AddMessage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyboardDemoDlg message handlers

BOOL CKeyboardDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
    SERIAL_PORT_Init();
    SERIAL_PORT_SetLogToFile(ENUM_INFO_LEVEL, "C:/SerialSdkLog/", TRUE);
    SERIAL_PORT_SetMessageCallBack(MessageDataCallBack, this);
    InitList();

    m_bUpdate = FALSE;
    //m_bStop = FALSE;

    InitializeCriticalSection(&m_struCritical);
    InitializeCriticalSection(&m_struMessageLock);
    InitializeCriticalSection(&m_struCallBackLock);
    InitializeCriticalSection(&m_struOnOffLine);
    m_hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);    
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CKeyboardDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKeyboardDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKeyboardDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CALLBACK CKeyboardDemoDlg::Hid_DATA_CB(BYTE *pDevPath, DWORD dwDevPathLen, BYTE byOnOffline, void* pUser)
{
    CKeyboardDemoDlg *ptr = (CKeyboardDemoDlg *)pUser;

    EnterCriticalSection(&ptr->m_struOnOffLine);
    EnterCriticalSection(&ptr->m_struCritical);

    ResetEvent(ptr->m_hEvent);
    char szLan[64];

    sprintf(szLan, "DevPath=%s,OnOffline=%d\n", pDevPath, byOnOffline);

    OutputDebugString(szLan);    
    
    memset(&struDevTemp, 0, sizeof(DEV_INFO));

    struDevTemp.lSerialHandle = -1;

    memcpy(struDevTemp.sComName, pDevPath, dwDevPathLen);
    
    if (byOnOffline)
    {
        ::PostMessage(ptr->m_hWnd, MESSAGE_DEV_ONLINE, (WPARAM)&struDevTemp, 0);
        //ptr->ProcessDevOnline(&struDevInfo);
    }
    else
    {
        ::PostMessage(ptr->m_hWnd, MESSAGE_DEV_OFFLINE, (WPARAM)&struDevTemp, 0);
        //ptr->ProcessDevOffline(&struDevInfo);
    }
    LeaveCriticalSection(&ptr->m_struCritical);

    //6룬һ¼꣬ٸstruDevTemp
    WaitForSingleObject(ptr->m_hEvent, 6000);
    LeaveCriticalSection(&ptr->m_struOnOffLine);
}

void CALLBACK CKeyboardDemoDlg::SerialDataCallback(LONG lSerialHandle, BYTE *pDataBuffer, DWORD dwBufLen, void* pUser)
{    
    if (pDataBuffer == NULL || dwBufLen != sizeof(SERIAL_PORT_KEYBOARD_COMMAND_INFO))
    {
        return;
    }

    CKeyboardDemoDlg *ptr = (CKeyboardDemoDlg *)pUser;
    HANDLE hMessage = NULL;
    
    EnterCriticalSection(&ptr->m_struCallBackLock);
    EnterCriticalSection(&ptr->m_struCritical);
    EnterCriticalSection(&ptr->m_struMessageLock);    
    
    int i = 0;

    for (i = 0; i < ptr->m_vDevInfo.size(); i++)
    {
        if (lSerialHandle == ptr->m_vDevInfo.at(i).lSerialHandle)
        {
            break;
        }
    }

    if (i >= ptr->m_vDevInfo.size())
    {
        LeaveCriticalSection(&ptr->m_struCritical);
        LeaveCriticalSection(&ptr->m_struMessageLock);
        return;
    }
    
    memcpy(&struMessage, &ptr->m_vDevInfo.at(i), sizeof(DEV_INFO));
    memcpy(&struCommand, pDataBuffer, sizeof(struCommand));
    hMessage = struMessage.hMessageFinish;
    ResetEvent(hMessage);
    ::PostMessage(ptr->m_hWnd, MESSAGE_ADD_MESSAGE, (WPARAM)&struMessage, (LPARAM)&struCommand);
    
    LeaveCriticalSection(&ptr->m_struCritical);   
    LeaveCriticalSection(&ptr->m_struMessageLock); 
    
    WaitForSingleObject(hMessage, INFINITE);

    LeaveCriticalSection(&ptr->m_struCallBackLock);
    
    //ptr->AddMessage(&ptr->m_vDevInfo.at(i), (SERIAL_PORT_KEYBOARD_COMMAND_INFO *)pDataBuffer);    

}

void CALLBACK CKeyboardDemoDlg::MessageDataCallBack(LONG lSerialHandle, DWORD dwMsgType, BYTE *pDataBuffer, DWORD dwBufLen, void *pUser)
{
    CKeyboardDemoDlg *ptr = (CKeyboardDemoDlg *)pUser;

    EnterCriticalSection(&ptr->m_struOnOffLine);
    EnterCriticalSection(&ptr->m_struCritical);
    
    int i = 0;

    for (i = 0; i < ptr->m_vDevInfo.size(); i++)
    {
        if (ptr->m_vDevInfo.at(i).lSerialHandle == lSerialHandle)
        {
            //ResetEvent(ptr->m_hEvent);
            struDevTemp = ptr->m_vDevInfo.at(i);
            ::PostMessage(ptr->m_hWnd, MESSAGE_DEV_OFFLINE, (WPARAM)&struDevTemp, 0);
            LeaveCriticalSection(&ptr->m_struCritical); 
            OutputDebugString("MessageDataCallBack step1\n");
            //WaitForSingleObject(ptr->m_hEvent, 6000);
            OutputDebugString("MessageDataCallBack step2\n");
            LeaveCriticalSection(&ptr->m_struOnOffLine);
            return;
        }
    }
    
    LeaveCriticalSection(&ptr->m_struCritical); 
    LeaveCriticalSection(&ptr->m_struOnOffLine);
}


void CKeyboardDemoDlg::OnBtnStartSearch() 
{
	// TODO: Add your control notification handler code here
    //m_bStop = TRUE;

    m_listDev.DeleteAllItems();
    int i = 0;
    int iDevNum = m_vDevInfo.size();
//     while (1)
//     {
//         COM_PARAM struParam = {0};
//         LONG lHandle = -1;
//         memcpy(struParam.szDevice, "..//COM4", strlen("..//COM4"));
//         struParam.byBaudRate = 13;
//         struParam.byByteSize = 3;
//         struParam.byParity = 0;
//         struParam.byStopBits = 0;
//         struParam.nProtocol = ENUM_SERIALPORT_KEYBOARD_PROTOCOL;
//         
//         BOOL bRet = FALSE;
//         
//         SERIAL_PORT_SERIAL_ADDRESS struAddress = {0};
//         SERIAL_PORT_DEV_INFO struDev = {0};
//         DWORD dwReturned = 0;
//         CString cs;
// 
//         lHandle = SERIAL_PORT_OpenComm(&struParam, NULL, NULL);
//         cs.Format("%d\n", lHandle);
//         OutputDebugString(cs);
//         //Sleep(500);
// 
//         SERIAL_PORT_CloseComm(lHandle);
//     }

    for (i = 0; i < iDevNum; i++)
    {
        SERIAL_PORT_SetDataCallBack(m_vDevInfo.at(i).lSerialHandle, NULL, NULL);
        SetEvent(m_vDevInfo.at(i).hMessageFinish);
        SERIAL_PORT_CloseComm(m_vDevInfo.at(i).lSerialHandle);
        CloseHandle(m_vDevInfo.at(i).hMessageFinish);
    }   

	if (!SERIAL_PORT_StartHidSearch(Hid_DATA_CB, this))
	{
        AfxMessageBox("SERIAL_PORT_StartHidSearch fail");        
    }

    //ﱣ֤Ч
    EnterCriticalSection(&m_struCritical);
    m_vDevInfo.clear();
    LeaveCriticalSection(&m_struCritical);
    SetTimer(NULL, 2000, NULL);
    m_bUpdate = TRUE;

    char szLan[32] = {0};
    g_StringLanType(szLan, "ˢ", "Updating");
    GetDlgItem(IDC_BTN_UPGRADE)->EnableWindow(FALSE);
    GetDlgItem(IDC_BTN_START_SEARCH)->EnableWindow(FALSE);
    GetDlgItem(IDC_BTN_START_SEARCH)->SetWindowText(szLan);
}



void CKeyboardDemoDlg::OnBtnStopSearch() 
{
	// TODO: Add your control notification handler code here
//     m_listDev.DeleteAllItems();
// 
//     int i = 0;
// 	int iDevNum = m_vDevInfo.size();
// 
//     for (i = 0; i < iDevNum; i++)
//     {
//         SERIAL_PORT_CloseComm(m_vDevInfo.at(i).lSerialHandle);
//     }
// 
//     m_vDevInfo.clear();

    SERIAL_PORT_StopHidSearch();
}

void CKeyboardDemoDlg::OnDestroy() 
{
	CDialog::OnDestroy();
    OutputDebugString("OnDestory\n");
    
    int i = 0;
    int iDevNum = m_vDevInfo.size();
    
    for (i = 0; i < iDevNum; i++)
    {
        SERIAL_PORT_SetDataCallBack(m_vDevInfo.at(i).lSerialHandle, NULL, NULL);
        SetEvent(m_vDevInfo.at(i).hMessageFinish);
        SERIAL_PORT_CloseComm(m_vDevInfo.at(i).lSerialHandle);
        CloseHandle(m_vDevInfo.at(i).hMessageFinish);
    }
    

    DeleteCriticalSection(&m_struCritical);
    DeleteCriticalSection(&m_struMessageLock);
    DeleteCriticalSection(&m_struCallBackLock);
    DeleteCriticalSection(&m_struOnOffLine);
    CloseHandle(m_hEvent);
	// TODO: Add your message handler code here
    SERIAL_PORT_Cleanup();
	
}

void CKeyboardDemoDlg::InitList()
{
    m_listDev.SetExtendedStyle(m_listDev.GetExtendedStyle() | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
    m_listMessage.SetExtendedStyle(m_listMessage.GetExtendedStyle() | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
    char szLan[64] = {0};

    g_StringLanType(szLan, "ں", "Serial port");
    m_listDev.InsertColumn(0, szLan, LVCFMT_LEFT, 60, -1);
    g_StringLanType(szLan, "豸", "Device type");
    m_listDev.InsertColumn(1, szLan, LVCFMT_LEFT, 60, -1);
    g_StringLanType(szLan, "汾", "Software version");
    m_listDev.InsertColumn(2, szLan, LVCFMT_LEFT, 80, -1);
    g_StringLanType(szLan, "Ӳ汾", "Hardware version");
    m_listDev.InsertColumn(3, szLan, LVCFMT_LEFT, 80, -1);
    g_StringLanType(szLan, "к", "Serial No.");
	m_listDev.InsertColumn(4, szLan, LVCFMT_LEFT, 160, -1);

    g_StringLanType(szLan, "ʱ", "Time");
    m_listMessage.InsertColumn(0, szLan, LVCFMT_LEFT, 120, -1);
    g_StringLanType(szLan, "Ϣ", "Message");
    m_listMessage.InsertColumn(1, szLan, LVCFMT_LEFT, 500, -1); 

    UpdateData(FALSE);
}

void CKeyboardDemoDlg::OnBtnExit() 
{
	// TODO: Add your control notification handler code here
	OnCancel();
}

LRESULT CKeyboardDemoDlg::ProcessDevOnline(WPARAM wParam, LPARAM lParam)
{
    EnterCriticalSection(&m_struCritical);
    LPDEV_INFO struDevInfo = (LPDEV_INFO)wParam;
    Sleep(200);
    COM_PARAM struParam = {0};
    LONG lHandle = -1;
    memcpy(struParam.szDevice, struDevInfo->sComName, strlen(struDevInfo->sComName));
    struParam.byBaudRate = 13;
    struParam.byByteSize = 3;
    struParam.byParity = 0;
    struParam.byStopBits = 0;
    struParam.nProtocol = ENUM_SERIALPORT_KEYBOARD_PROTOCOL;

    BOOL bRet = FALSE;
    
    SERIAL_PORT_SERIAL_ADDRESS struAddress = {0};
    SERIAL_PORT_DEV_INFO struDev = {0};
    DWORD dwReturned = 0;

    lHandle = SERIAL_PORT_OpenComm(&struParam, NULL, NULL);

    if (lHandle != -1)
    {
        struDevInfo->lSerialHandle = lHandle;

        if (SERIAL_PORT_GetDeviceConfig(lHandle, SERIAL_PORT_GET_DEV_INFO, &struAddress, NULL, 0, &struDev, sizeof(struDev), &dwReturned))
        {
            struDevInfo->wDevType = struDev.wDevType;            
            bRet = TRUE;
        }
        else
        {
            OutputDebugString("SERIAL_PORT_GetDeviceConfig fail");
            bRet = FALSE;
        }
        
        struDevInfo->hMessageFinish = CreateEvent(NULL, TRUE, FALSE, NULL);

        SERIAL_PORT_SetDataCallBack(lHandle, SerialDataCallback, this);
        InsertDevList(struDevInfo, &struDev);        
        DEV_INFO struTemp = {0};
        
        memcpy(&struTemp, struDevInfo, sizeof(DEV_INFO));
        m_vDevInfo.push_back(struTemp);
        
    }
    else
    {
        OutputDebugString("SERIAL_PORT_OpenComm fail");
        bRet =  FALSE;
    } 

    LeaveCriticalSection(&m_struCritical);

    SetEvent(m_hEvent);

    return bRet;
}

LRESULT CKeyboardDemoDlg::ProcessDevOffline(WPARAM wParam, LPARAM lParam)
{
    EnterCriticalSection(&m_struCritical);
    LPDEV_INFO struDevInfo = (LPDEV_INFO)wParam;
    int i = 0;
    BOOL bRet = FALSE;

    for (i = 0; i < m_vDevInfo.size(); i++)
    {
        if (!strcmp(struDevInfo->sComName, m_vDevInfo.at(i).sComName))
        {
            SERIAL_PORT_SetDataCallBack(m_vDevInfo.at(i).lSerialHandle, NULL, NULL);
            SetEvent(m_vDevInfo.at(i).hMessageFinish);
            bRet = SERIAL_PORT_CloseComm(m_vDevInfo.at(i).lSerialHandle);            
            if (bRet)
            {
                OutputDebugString("SERIAL_PORT_CloseComm succ\n");
            }
            else
            {
                OutputDebugString("SERIAL_PORT_CloseComm fail\n");
            }

            CloseHandle(struDevInfo->hMessageFinish);
            EraseDevList(struDevInfo);
            m_vDevInfo.erase(&m_vDevInfo.at(i));            
        }
    }

    LeaveCriticalSection(&m_struCritical);

    OutputDebugString("ProcessDevOffline set event\n");
    SetEvent(m_hEvent);
    return TRUE;
}

void CKeyboardDemoDlg::EraseDevList(DEV_INFO *struDevInfo)
{
    int i = 0;
    char szLan[64] = {0};

    sprintf(szLan, "%s", struDevInfo->sComName + strlen("\\\\.\\"));

    for (i = 0; i < m_listDev.GetItemCount(); i++)
    {
        if (!strcmp(szLan, m_listDev.GetItemText(i, 0)))
        {
            m_listDev.DeleteItem(i);
        }
    }
}

void CKeyboardDemoDlg::InsertDevList(DEV_INFO *struDevInfo, SERIAL_PORT_DEV_INFO *struDev)
{
    
    char szLan[64] = {0};

    int iCount = m_listDev.GetItemCount();
	sprintf(szLan, "%s", struDevInfo->sComName + strlen("\\\\.\\"));

    m_listDev.InsertItem(iCount, szLan);        

	if (struDev->wDevType == DS_1005K)
	{
		sprintf(szLan, "DS-1005K");
	}
	else
	{
		sprintf(szLan, "Unknown");
	}
    m_listDev.SetItemText(iCount, 1, szLan);
    sprintf(szLan, "V%d.%d.%d", struDev->dwSoftWareVersion >> 24, (struDev->dwSoftWareVersion & 0x00ff0000) >> 16, struDev->dwSoftWareVersion & 0x0000ffff);
    m_listDev.SetItemText(iCount, 2, szLan);
    sprintf(szLan, "V%d.%d.%d", struDev->dwHardWareVersion >> 24, (struDev->dwHardWareVersion & 0x00ff0000) >> 16, struDev->dwHardWareVersion & 0x0000ffff);
    m_listDev.SetItemText(iCount, 3, szLan);
	sprintf(szLan, "%s", struDev->sSerialNumber);
	m_listDev.SetItemText(iCount, 4, szLan);
}

LRESULT CKeyboardDemoDlg::AddMessage(WPARAM wParam, LPARAM lParam)
{
    EnterCriticalSection(&m_struMessageLock);

    DEV_INFO *pStruDevInfo = (DEV_INFO *)wParam;
    SERIAL_PORT_KEYBOARD_COMMAND_INFO *pStruMessage = (SERIAL_PORT_KEYBOARD_COMMAND_INFO *)lParam;
    CTime ct;
    ct = CTime::GetCurrentTime();
    CString csMessage;
    CString csTemp;
    char szLan[64] = {0};

    if (m_listMessage.GetItemCount() > 10000)
    {
        m_listMessage.DeleteAllItems();
    }

    csTemp.Format("%d-%02d-%02d %02d:%02d:%02d", ct.GetYear(), ct.GetMonth(), ct.GetDay(), ct.GetHour(), ct.GetMinute(), ct.GetSecond());

    m_listMessage.InsertItem(0, csTemp);

    csTemp = pStruDevInfo->sComName + strlen("\\\\.\\");
    csMessage = csTemp + " ";

    csTemp.Empty();

    g_StringLanType(szLan, "ģʽ:", "Command Mode:");
    switch (pStruMessage->byCtrlMode)
    {
    case 1:        
        csTemp.Format("%swin ", szLan);
    	break;
    case 2:
        csTemp.Format("%scam ", szLan);
        break;
    default:
        break;
    }

    csMessage += csTemp;
    csTemp.Empty();

    g_StringLanType(szLan, "ٶȵȼ:", "Speed level num:");

    switch (pStruMessage->bySpeedLevelNum)
    {
    case 0:
    case 0xff:
        csTemp.Format("%s7",szLan);
    	break;
    default:
        csTemp.Format("%s%d", szLan, pStruMessage->bySpeedLevelNum);
        break;
    }

    csMessage += csTemp;

    csTemp.Empty();
    if (pStruMessage->dwKeyNo != 0xffffffff)
    {
        g_StringLanType(szLan, "ֵ̼:", "Button:");
        csTemp.Format("%s%d ", szLan, pStruMessage->dwKeyNo);
    }

    csMessage += csTemp;

    csTemp.Empty();

    switch (pStruMessage->bySelfDefineKey)
    {
    case 1:
        g_StringLanType(szLan, "Զ尴:F1 ", "Self define key:F1 press ");
        csTemp = szLan;
        break;
    case 2:
        g_StringLanType(szLan, "Զ尴:F1ɿ ", "Self define key:F1 release ");
        csTemp = szLan;
        break;
    case 3:
        g_StringLanType(szLan, "Զ尴:F2 ", "Self define key:F2 press ");
        csTemp = szLan;
        break;
    case 4:
        g_StringLanType(szLan, "Զ尴:F2ɿ ", "Self define key:F2 release ");
        csTemp = szLan;
        break;
    case 5:
        g_StringLanType(szLan, "Զ尴:F3 ", "Self define key:F3 press ");
        csTemp = szLan;
        break;
    case 6:
        g_StringLanType(szLan, "Զ尴:F3ɿ ", "Self define key:F3 release ");
        csTemp = szLan;
        break;
    default:
        break;
    }

    csMessage += csTemp;

    csTemp.Empty();

    switch (pStruMessage->byJoystickKey)
    {
    case 1:
        g_StringLanType(szLan, "ҡ˼ֵ: ", "Joystick:Left ");
        csTemp = szLan;
        break;
    case 2:
        g_StringLanType(szLan, "ҡ˼ֵ: ", "Joystick:Right ");
        csTemp = szLan;
        break;
    case 3:
        g_StringLanType(szLan, "ҡ˼ֵ: ", "Joystick:Up ");
        csTemp = szLan;
        break;
    case 4:
        g_StringLanType(szLan, "ҡ˼ֵ: ", "Joystick:Down ");
        csTemp = szLan;
        break;
    case 5:
        g_StringLanType(szLan, "ҡ˼ֵ:ֹͣ ", "Joystick:Stop ");
        csTemp = szLan;
        break;
    case 6:
        g_StringLanType(szLan, "ҡ˼ֵ: ", "Joystick:Up-Left ");
        csTemp = szLan;
        break;
    case 7:
        g_StringLanType(szLan, "ҡ˼ֵ: ", "Joystick:Down-Left ");
        csTemp = szLan;
        break;
    case 8:
        g_StringLanType(szLan, "ҡ˼ֵ: ", "Joystick:Up-Right ");
        csTemp = szLan;
        break;
    case 9:
        g_StringLanType(szLan, "ҡ˼ֵ: ", "Joystick:Down-Right ");
        csTemp = szLan;
        break;
    default:
        break;        
    }

    csMessage += csTemp;

    csTemp.Empty();

    if (pStruMessage->byJoystickKeySpeedX != 0xff)
    {
        g_StringLanType(szLan, "ҡٶX:", "Joystick speed X:");
        csTemp.Format("%s%d ", szLan, pStruMessage->byJoystickKeySpeedX);
    }

    csMessage += csTemp;
    csTemp.Empty();

    if (pStruMessage->byJoystickKeySpeedY != 0xff)
    {
        g_StringLanType(szLan, "ҡٶY:", "Joystick speed Y:");
        csTemp.Format("%s%d ", szLan, pStruMessage->byJoystickKeySpeedY);
    }

    csMessage += csTemp;
    csTemp.Empty();

    switch (pStruMessage->byJoystickAction)
    {
    case 1:
        g_StringLanType(szLan, "ҡ˶˳ʱ ", "Joystick action:clockwise ");
        csTemp = szLan;
    	break;
    case 2:
        g_StringLanType(szLan, "ҡ˶ʱ ", "Joystick action:anticlockwise ");
        csTemp = szLan;
    	break;
    case 3:
        g_StringLanType(szLan, "ҡ˶ֹͣ ", "Joystick action:stop ");
        csTemp = szLan;
    	break;
    default:
        break;
    }

    csMessage += csTemp;

    csTemp.Empty();

    if (pStruMessage->byJoystickActionSpeed != 0xff)
    {
        g_StringLanType(szLan, "ҡ˶ٶ:", "Joystick action speed:");
        csTemp.Format("%s%d ", szLan, pStruMessage->byJoystickActionSpeed);
    }

    csMessage += csTemp;

    csTemp.Empty();

    switch (pStruMessage->byJoyKeyButton)
    {
    case 1:
        g_StringLanType(szLan, "ҡ ", "Joystick left button ");
        csTemp = szLan;
    	break;
    case 2:
        g_StringLanType(szLan, "ҡҼ ", "Joystick right button");
        csTemp = szLan;
        break;
    default:
        break;
    }

    csMessage += csTemp;

    m_listMessage.SetItemText(0, 1, csMessage);

    SetEvent(pStruDevInfo->hMessageFinish);
    LeaveCriticalSection(&m_struMessageLock);
    return 0;
}

void CKeyboardDemoDlg::OnBtnUpgrade() 
{
	// TODO: Add your control notification handler code here
    char szLan[64] = {0};

    POSITION  iPos = m_listDev.GetFirstSelectedItemPosition();
    if (iPos == NULL)
    {
        g_StringLanType(szLan, "ѡһ豸", "Please select a device");
        AfxMessageBox(szLan);
        return;
    }

	int iSel = m_listDev.GetNextSelectedItem(iPos);

    if (iSel < 0)
    {
        g_StringLanType(szLan, "ѡһ豸", "Please select a device");
        AfxMessageBox(szLan);
        return;
    }

    int i = 0;
    CString csTemp;


    EnterCriticalSection(&m_struCritical);

    for (i = 0; i < m_vDevInfo.size(); i++)
    {
        csTemp = m_listDev.GetItemText(iSel, 0);        

        if (strstr(m_vDevInfo[i].sComName, csTemp))
        {
            break;
        }
    }

    if (i >= m_vDevInfo.size())
    {
        AfxMessageBox("Error");
        return;
    }

    SERIAL_PORT_SERIAL_ADDRESS struAddress = {0};

    

    if (!SERIAL_PORT_ControlDevice(m_vDevInfo[i].lSerialHandle, SERIAL_PORT_KEYBOARD_UPGRADE, &struAddress, NULL, 0, NULL, 0))
    {
        PostMessage(MESSAGE_DEV_OFFLINE, (WPARAM)&m_vDevInfo.at(i), 0);
        g_StringLanType(szLan, "ʧ", "Upgrade fail");
        LeaveCriticalSection(&m_struCritical);      
        AfxMessageBox(szLan);
        //return;
    }
    else
    {
        PostMessage(MESSAGE_DEV_OFFLINE, (WPARAM)&m_vDevInfo.at(i), 0);
        g_StringLanType(szLan, "", "Upgrading");
        LeaveCriticalSection(&m_struCritical);
        AfxMessageBox(szLan);
    }    
    
}

void CKeyboardDemoDlg::OnButTest() 
{
	// TODO: Add your control notification handler code here
	HANDLE hTestHandle = INVALID_HANDLE_VALUE;

    hTestHandle = CreateFile("COM1", GENERIC_READ|GENERIC_WRITE, FILE_SHARE_DELETE | FILE_SHARE_READ | FILE_SHARE_WRITE, 0 , OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,0);

    if (hTestHandle == INVALID_HANDLE_VALUE)
    {
        int iErr = -1;
        char szErr[32] = {0};
        iErr = GetLastError();
        sprintf(szErr, "system error = %d", iErr);
        AfxMessageBox(szErr);
    }
    else
    {
        CloseHandle(hTestHandle);
        AfxMessageBox("Success");
    }
}

void CKeyboardDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default    
	if (m_bUpdate)
	{
        char szLan[64] = {0};
        OnBtnStopSearch();
        GetDlgItem(IDC_BTN_UPGRADE)->EnableWindow(TRUE);
        GetDlgItem(IDC_BTN_START_SEARCH)->EnableWindow(TRUE);
        g_StringLanType(szLan, "ˢ豸", "Update device");
        GetDlgItem(IDC_BTN_START_SEARCH)->SetWindowText(szLan);
        KillTimer(NULL);
        m_bUpdate = FALSE;
        //m_bStop = FALSE;
	}
    
	CDialog::OnTimer(nIDEvent);
}


